Package org.eclipse.cdt.core.model

# Class AssemblyLanguage

java.lang.Object
org.eclipse.core.runtime.PlatformObject
org.eclipse.cdt.core.model.AbstractLanguage
org.eclipse.cdt.core.model.AssemblyLanguage

All Implemented Interfaces:
  `IAsmLanguage`, `ILanguage`, `org.eclipse.core.runtime.IAdaptable`, `org.eclipse.core.runtime.IExecutableExtension`

public class AssemblyLanguage extends AbstractLanguage implements IAsmLanguage, org.eclipse.core.runtime.IExecutableExtension
Built-in language for assembly files.

Since:
  4.0

## Field Summary

Fields
Modifier and Type
Field
Description
`static final AssemblyLanguage`
`DEFAULT_INSTANCE`

### Fields inherited from interface org.eclipse.cdt.core.model.ILanguage

`OPTION_ADD_COMMENTS, OPTION_IS_SOURCE_UNIT, OPTION_NO_IMAGE_LOCATIONS, OPTION_PARSE_INACTIVE_CODE, OPTION_SKIP_FUNCTION_BODIES, OPTION_SKIP_TRIVIAL_EXPRESSIONS_IN_AGGREGATE_INITIALIZERS`

## Constructor Summary

Constructors
Constructor
Description
`AssemblyLanguage()`

## Method Summary

Modifier and Type
Method
Description
`IContributedModelBuilder`
`createModelBuilder(ITranslationUnit tu)`
Used to override the default model building behavior for a translation unit.
`IASTTranslationUnit`
`getASTTranslationUnit(CodeReader reader, IScannerInfo scanInfo, ICodeReaderFactory fileCreator, IIndex index, IParserLogService log)`
Deprecated.
`IASTCompletionNode`
`getCompletionNode(CodeReader reader, IScannerInfo scanInfo, ICodeReaderFactory fileCreator, IIndex index, IParserLogService log, int offset)`
Deprecated.
`static AssemblyLanguage`
`getDefault()`
`String[]`
`getDirectiveKeywords()`
Get the set of assembler directives defined for this variant.
`String`
`getId()`
Return the language id for this language.
`char[]`
`getLineCommentCharacters()`
Get the set of valid line comment characters defined for this assembly variant.
`char`
`getLineSeparatorCharacter()`
Get the line separator character defined for this assembly variant.
`int`
`getLinkageID()`
Return the id of the linkage this language contributes to.
`String[]`
`getPreprocessorKeywords()`
Get the preprocessor keywords (directives) defined for this variant.
`IASTName[]`
`getSelectedNames(IASTTranslationUnit ast, int start, int length)`
`void`
`setInitializationData(org.eclipse.core.runtime.IConfigurationElement config, String propertyName, Object data)`

### Methods inherited from class org.eclipse.cdt.core.model.AbstractLanguage

`getASTTranslationUnit, getASTTranslationUnit, getCompletionNode, getName`

### Methods inherited from class org.eclipse.core.runtime.PlatformObject

`getAdapter`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.eclipse.core.runtime.IAdaptable

`getAdapter`

## Field Details

### DEFAULT_INSTANCE

public static final AssemblyLanguage DEFAULT_INSTANCE

## Constructor Details

### AssemblyLanguage

public AssemblyLanguage()

## Method Details

### getDefault

public static AssemblyLanguage getDefault()

Returns:
  the default language instance

### createModelBuilder

public IContributedModelBuilder createModelBuilder(ITranslationUnit tu)
Description copied from interface: `ILanguage`
Used to override the default model building behavior for a translation unit.

Specified by:
  `createModelBuilder` in interface `ILanguage`
Parameters:
  `tu` - the `ITranslationUnit` to be parsed (non-`null`)
Returns:
  an `IModelBuilder`, which parses the given translation unit and returns the `ICElement`s of its model, or `null` to parse using the default CDT model builder

### getASTTranslationUnit

@Deprecated public IASTTranslationUnit getASTTranslationUnit(CodeReader reader, IScannerInfo scanInfo, ICodeReaderFactory fileCreator, IIndex index, IParserLogService log) throws org.eclipse.core.runtime.CoreException
Deprecated.

Specified by:
  `getASTTranslationUnit` in interface `ILanguage`
Throws:
  `org.eclipse.core.runtime.CoreException`

### getCompletionNode

@Deprecated public IASTCompletionNode getCompletionNode(CodeReader reader, IScannerInfo scanInfo, ICodeReaderFactory fileCreator, IIndex index, IParserLogService log, int offset) throws org.eclipse.core.runtime.CoreException
Deprecated.

Specified by:
  `getCompletionNode` in interface `ILanguage`
Throws:
  `org.eclipse.core.runtime.CoreException`

### getId

public String getId()
Description copied from interface: `ILanguage`
Return the language id for this language. This is to differentiate languages from each other.

Specified by:
  `getId` in interface `ILanguage`

### getSelectedNames

public IASTName[] getSelectedNames(IASTTranslationUnit ast, int start, int length)

Specified by:
  `getSelectedNames` in interface `ILanguage`

### getLineCommentCharacters

public char[] getLineCommentCharacters()
Description copied from interface: `IAsmLanguage`
Get the set of valid line comment characters defined for this assembly variant.

Specified by:
  `getLineCommentCharacters` in interface `IAsmLanguage`
Returns:
  an array line comment characters

### getLineSeparatorCharacter

public char getLineSeparatorCharacter()
Description copied from interface: `IAsmLanguage`
Get the line separator character defined for this assembly variant. The line separator character is used to split physical lines into logical lines. `'\0'` means that no line separator character is defined.

Specified by:
  `getLineSeparatorCharacter` in interface `IAsmLanguage`
Returns:
  the line separator character or `'\0'`

### getDirectiveKeywords

public String[] getDirectiveKeywords()
Description copied from interface: `IAsmLanguage`
Get the set of assembler directives defined for this variant.

Specified by:
  `getDirectiveKeywords` in interface `IAsmLanguage`
Returns:
  an array of keywords

### getPreprocessorKeywords

public String[] getPreprocessorKeywords()
Description copied from interface: `IAsmLanguage`
Get the preprocessor keywords (directives) defined for this variant.

Specified by:
  `getPreprocessorKeywords` in interface `IAsmLanguage`
Returns:
  an array of keywords

### setInitializationData

public void setInitializationData(org.eclipse.core.runtime.IConfigurationElement config, String propertyName, Object data) throws org.eclipse.core.runtime.CoreException

Specified by:
  `setInitializationData` in interface `org.eclipse.core.runtime.IExecutableExtension`
Throws:
  `org.eclipse.core.runtime.CoreException`

### getLinkageID

public int getLinkageID()
Description copied from interface: `ILanguage`
Return the id of the linkage this language contributes to. This is especially important for languages that write to the index.

Specified by:
  `getLinkageID` in interface `ILanguage`
See Also:
  - `ILinkage`